package br.com.ages.mutiraodobemback.controller;

import br.com.ages.mutiraodobemback.dto.EventRequestDTO;
import br.com.ages.mutiraodobemback.dto.EventResponseDTO;
import br.com.ages.mutiraodobemback.service.event.IEventService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/events")
public class EventController {

    private final IEventService service;

    @Autowired
    public EventController(IEventService service) {
        this.service = service;
    }

    @PostMapping
    public EventResponseDTO save(@RequestBody EventRequestDTO event) {
        return service.save(event);
    }

    @PatchMapping
    public EventResponseDTO update(@RequestBody EventRequestDTO event) {
        return service.update(event);
    }

    @GetMapping
    public List<EventRequestDTO> findAll() {
        return service.findAll();
    }

    @GetMapping("/all-active")
    public List<EventResponseDTO> findAllActive(){ return service.findAllActive(); }
}
