package br.com.ages.mutiraodobemback.dto;

import br.com.ages.mutiraodobemback.domain.EventEntity;
import br.com.ages.mutiraodobemback.domain.UserEntity;
import com.fasterxml.jackson.annotation.JsonInclude;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDateTime;
import java.util.List;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_NULL)
public class EventResponseDTO {

    private String id;
    private String title;
    private String description;
    private String phone;
    private LocalDateTime startDate;
    private LocalDateTime endDate;
    private LocalDateTime createdDate;
    private List<String> images;
    private List<String> tasks;
    private UserEntity user;
    private String eventType;
    private String street;
    private String latitude;
    private String longitude;
    private boolean active;

    public EventResponseDTO(EventEntity eventEntity) {
        this.id = eventEntity.getId();
        this.title = eventEntity.getTitle();
        this.street = eventEntity.getAddress().getStreet();
        this.latitude = eventEntity.getAddress().getLatitude();
        this.longitude = eventEntity.getAddress().getLongitude();
        this.description = eventEntity.getDescription();
        this.phone = eventEntity.getPhone();
        this.startDate = LocalDateTime.now();
        this.endDate = eventEntity.getEndDate();
        this.createdDate = eventEntity.getCreatedDate();
        this.images = eventEntity.getImages();
        this.tasks = eventEntity.getTasks();
        this.user = eventEntity.getUser();
        this.eventType = eventEntity.getEventType();
        this.active = eventEntity.isActive();
    }

}
